#include <PalmOS.h>
#include <SysEvtMgr.h>
#include <DataMgr.h>
#include "treohelper.h"

void start(char *Token, char *ReturnString);
void GetNthVar(char *var, char *Token, Int16 Nth);

/* this function must remain first */

void start(char *Token, char *ReturnString)
{
    char *t;
    char *p;
    UInt16 n;
    Int16 l;

    if (!(t = MemPtrNew(40))) return;
    GetNthVar(t, Token, 1);
    n = StrAToI(t);
    l = StrLen(ReturnString);

    /* retrieve SMS text from feature memory */
    if (!FtrGet(MainAppID, 1001+n, (UInt32 *)&p)) {
        l = 80-l;
        if (l > 0) {
            StrNCat(ReturnString, p, l);
            ReturnString[l] = (char)NULL;
        }
    }

    MemPtrFree(t);
}

void GetNthVar(char *var, char *Token, Int16 Nth)
{
    Int16 i;
    Int16 i1;
    Int16 tLen;
    Int16 Count=Nth+1;

    tLen = StrLen(Token);
    i1 = 0;
    for (i=0; i < tLen; i++) {
        if (Token[i] == ':') Count--;
        if ((Token[i] == ':') && (Count == 0)) i1 = i++;
        if ((Token[i] == ':') && (Count < 0)) break;
    }
    if (Count > 0) {
        StrCopy(var, "");
        return;
    }

    StrNCopy(var, Token+i1+1, i-i1-1);
    var[i-i1-1] = 0;
}
